Port tests/rmdir/ignore away from GNU/Linux.
[coreutils/ericb.git] / tests / tail-2 / big-4gb
blob5494e3dc429217a98585de5cb4ff1f8df84089b4
1 #!/bin/sh
2 # Demonstrate a bug in `tail -cN' when operating on files of size 4G and larger
3 # Fixed in coreutils-4.5.2.
5 # Copyright (C) 2002, 2003, 2006-2007 Free Software Foundation, Inc.
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
17 # You should have received a copy of the GNU General Public License
18 # along with this program. If not, see <http://www.gnu.org/licenses/>.
20 if test "$VERBOSE" = yes; then
21 set -x
22 tail --version
25 . $srcdir/../expensive
26 . $srcdir/../test-lib.sh
28 # Create a file of size exactly 4GB (2^32) with 8 bytes
29 # at the beginning and another set of 8 bytes at the end.
30 # The rest will be NUL bytes. On most modern systems, the following
31 # creates a file that takes up only a few KB. Here, du -sh says 16K.
32 echo abcdefgh | tr -d '\n' > big || framework_failure
33 echo 87654321 | tr -d '\n' > tmp || framework_failure
34 # Seek 4GB - 8
35 dd bs=1 seek=4294967288 if=tmp of=big 2> err || dd_failed=1
36 if test "$dd_failed" = 1; then
37 cat err 1>&2
38 echo "$0: cannot create a file large enough for this test," 1>&2
39 echo "$0: possibly because this system doesn't support large files;" 1>&2
40 echo "$0: Consider rerunning this test on a different file system." 1>&2
41 (exit 77); exit 77
44 fail=0
46 tail -c1 big > out || fail=1
47 # Append a newline.
48 echo >> out
49 cat <<\EOF > exp
51 EOF
53 compare out exp || fail=1
55 (exit $fail); exit $fail